;
; STERCORE 264 Startup
;

; Programmed for the converted game by gerliczer

; Notes: this source is formatted for the ACME cross assembler from
; http://sourceforge.net/projects/acme-crossass/
; Compression is handled with Exomizer 2 which can be downloaded at
; http://hem.bre!byteand.net/magli143/exo/

; build_264.cmd will call both to create an assembled file, next the
; crunched release version and finally the linked runable programme

; Add a BASIC startline
		* = $1001
		!word code_start-2
		!byte <2019,>2019,$9e
		!text "4109"
		!byte $00,$00,$00

code_start
; Write messages
		jsr $ff84
		jsr $ff81
		lda #$ff
		sta $ff0d
		sta $ff0c
		ldy #1
		ldx #1
		clc
		jsr $fff0
		jsr $ff4f
		!text "STERCORE 264"
		!byte 0
		ldy #1
		ldx #3
		clc
		jsr $fff0
		jsr $ff4f
		!text "C64 ORIGINAL RELEASED BY"
		!byte 0
		ldy #27
		ldx #4
		clc
		jsr $fff0
		jsr $ff4f
		!text "T.M.R/COSINE"
		!byte 0
		ldy #1
		ldx #6
		clc
		jsr $fff0
		jsr $ff4f
		!text "BITS & BYTES BENT OUT OF SHAPE TO FIT"
		!byte 0
		ldy #1
		ldx #7
		clc
		jsr $fff0
		jsr $ff4f
		!text "THE PAL 264 SERIES WITH 64K BY"
		!byte 0
		ldy #30
		ldx #8
		clc
		jsr $fff0
		jsr $ff4f
		!text "GERLICZER"
		!byte 0
		ldy #1
		ldx #10
		clc
		jsr $fff0
		jsr $ff4f
		!text "THANKS IN NO PARTICULAR ORDER TO"
		!byte 0
		ldy #27
		ldx #12
		clc
		jsr $fff0
		jsr $ff4f
		!text "TLC/CORONERS"
		!byte 0
		ldy #28
		ldx #13
		clc
		jsr $fff0
		jsr $ff4f
		!text "SIZ/ABSENCE"
		!byte 0
		ldy #24
		ldx #14
		clc
		jsr $fff0
		jsr $ff4f
		!text "SKORO/ASSASSINS"
		!byte 0
		ldy #23
		ldx #15
		clc
		jsr $fff0
		jsr $ff4f
		!text "RACHY/METHABOLIX"
		!byte 0
		ldy #1
		ldx #17
		clc
		jsr $fff0
		jsr $ff4f
		!text "GREETINGS TO"
		!byte 0
		ldy #1
		ldx #19
		clc
		jsr $fff0
		jsr $ff4f
		!text "CSABO LUCA MMS GEORGE GAIA ISTVANV SVS"
		!byte 0
		ldy #1
		ldx #20
		clc
		jsr $fff0
		jsr $ff4f
		!text "MAD DEGAUSS LAVINA BSZ CHICKEN CHRONOS"
		!byte 0
		ldy #3
		ldx #21
		clc
		jsr $fff0
		jsr $ff4f
		!text "KICHY & ALL OTHERS FROM PLUS4WORLD"
		!byte 0
		ldy #22
		ldx #23
		clc
		jsr $fff0
		jsr $ff4f
		!text "END OF JUNE, 2019"
		!byte 0
; Give time to read the above cr*p
		ldy #1
		ldx #0
		lda #$f0
loop	cmp $ff1d
		bne loop
wait	cmp $ff1d
		beq wait
		dex
		bne loop
		dey
		bne loop
; Fade out, PAL check and continuing or exit
		jsr fadeBorder	; fading border
		jsr flushScreen	; clearing screen
		jsr closeScreen
		jsr checkSystem
isPal
		lda #0
		beq quit
		jmp dataStart+2
quit
		jmp $FFF6

; Fading border colour to black in an increasing delay fashion.
fadeBorder
		lda $FF19	; check if border color is black
		and #$0F
		cmp #0
		beq exitFadeBorder
loopFadeBorder
		ldx #2		; delay colour change
waitFadeBorderDelay
		lda #$FF
		cmp $FF1D
		bne *-3
		cmp $FF1D
		beq *-3
		dex
		bne waitFadeBorderDelay
		inc loopFadeBorder+1
		lda $FF19	; decrease shade
		sec
		sbc #$10
		sta $FF19
		and #$70	; check if already darkest
		bne loopFadeBorder
		lda #0
		sta $FF19
exitFadeBorder
		rts

; Flush screen to black from left to right with delay between rows.
flushScreen
		ldy #65
flushScreenCycle
		ldx #2
waitFlushScreenCycle
		lda #$FF
		cmp $FF1D
		bne *-3
		cmp $FF1D
		beq *-3
		dex
		bne waitFlushScreenCycle
flushVariableAccess
		inc flushRowPositions
		ldx flushRowPositions
		bmi skipFlushRow
		cpx #40
		beq skipFlushRow
		lda #0
flushScreenLuma
		sta $0800,x
		lda #160
flushScreenChroma
		sta $0C00,x
skipFlushRow
		lda flushVariableAccess+1
		cmp #<(flushRowPositions+24)
		beq resetFlushPointers 
		inc flushVariableAccess+1
		inc flushVariableAccess+4
		lda flushScreenLuma+1
		clc
		adc #$28
		sta flushScreenLuma+1
		sta flushScreenChroma+1
		bcc skipHiByteIncrement
		inc flushScreenLuma+2
		inc flushScreenChroma+2
skipHiByteIncrement
		jmp flushVariableAccess
resetFlushPointers
		lda #<flushRowPositions
		sta flushVariableAccess+1
		sta flushVariableAccess+4
		lda #$08
		sta flushScreenLuma+2
		lda #$0C
		sta flushScreenChroma+2
		lda #0
		sta flushScreenLuma+1
		sta flushScreenChroma+1
		dey
		bne flushScreenCycle
		rts

		* = $1300

flushRowPositions
		!byte  -1,  -2,  -3,  -4,  -5,  -6,  -7,  -8
		!byte  -9, -10, -11, -12, -13, -14, -15, -16
		!byte -17, -18, -19, -20, -21, -22, -23, -24
		!byte -25

closeScreen
		lda #$FF
		cmp $FF1D
		bne *-3
		lda #07
		sta $FF06
		rts

checkSystem
		lda #$FF
waitScreenTop
		cmp $FF1C
		bne waitScreenTop
		lda #$FE
waitScreenStart
		cmp $FF1C
		bne waitScreenStart
		lda #$FF
waitScreenTop2
		cmp $FF1C
		bne waitScreenTop2
readRaster
		ldx $FF1D
		txa
waitNextRaster
		cpx $FF1D
		beq waitNextRaster
		ldx $FF1D
		bne readRaster
		and #$20
		sta isPal+1
		rts

dataStart = *
i_load_addr = dataStart+2	; for exomizer
